<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_FareGroup StructType
 * @subpackage Structs
 */
class JP_FareGroup extends AbstractStructBase
{
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The FareGroupServices
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_FareGroupService
     */
    public $FareGroupServices;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * Constructor method for JP_FareGroup
     * @uses JP_FareGroup::setName()
     * @uses JP_FareGroup::setFareGroupServices()
     * @uses JP_FareGroup::setCode()
     * @param string $name
     * @param \ArrayType\ArrayOfJP_FareGroupService $fareGroupServices
     * @param string $code
     */
    public function __construct($name = null, \ArrayType\ArrayOfJP_FareGroupService $fareGroupServices = null, $code = null)
    {
        $this
            ->setName($name)
            ->setFareGroupServices($fareGroupServices)
            ->setCode($code);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_FareGroup
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get FareGroupServices value
     * @return \ArrayType\ArrayOfJP_FareGroupService|null
     */
    public function getFareGroupServices()
    {
        return $this->FareGroupServices;
    }
    /**
     * Set FareGroupServices value
     * @param \ArrayType\ArrayOfJP_FareGroupService $fareGroupServices
     * @return \StructType\JP_FareGroup
     */
    public function setFareGroupServices(\ArrayType\ArrayOfJP_FareGroupService $fareGroupServices = null)
    {
        $this->FareGroupServices = $fareGroupServices;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_FareGroup
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_FareGroup
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
